﻿---
sidebar_position: 2
---

# Logo Usage Guidelines

The Modular Avatar logo is intended to indicate to users that products can be easily installed using Modular Avatar in a consistent way. To avoid confusion, please follow these guidelines when using the Modular Avatar logo in advertising your products.

While you are not required to request permission prior to using the logo in accordance with these guidelines, the final determination of whether logo usage is appropriate will be up to [bd_](https://misskey.niri.la/@bd_) and [pumo](https://twitter.com/pumony); upon request, you must remove your use of the logo.

Additionally, in some cases it may be possible to approve usage of the logo even if it does not meet the requirements stated here. Please contact bd_ if you have any questions or if you would like to discuss special usage permission.

## Applicable products

- The logo may be applied to advertise products like avatars or outfits that make use of Modular Avatar in a prefab.
  - The prefab in question must contain preconfigured Modular Avatar components. 
  - You may include alternate prefabs that do not make use of Modular Avatar, but Modular Avatar should be a primary supported way of installing your asset.
- The logo may also be applied to non-destructive editor extensions intended for use in avatar authoring 
  which make use of [NDM Framework](https://github.com/bdunderscore/ndmf), and which are compatible with (or which require as a dependency) Modular Avatar. 
  - When using with editor extensions, your editor extension must not make destructive changes to the original avatar. This means that uninstalling your asset must be achievable by deleting the prefab object from the avatar.
  - Your asset must not require the user to manually trigger any kind of processing or generation operation as part of installation or after changing settings.
  - Your asset must not use the Modular Avatar logo in any UI it adds. This is to make it clear which parts of the UI 
    are from Modular Avatar itself. 
- The logo should not be presented in a way that makes it seem like Modular Avatar has approved of or endorsed your product.
- Provided that your product meets the requirements stated here, you may use the logo to advertise both commercial and
  noncommercial products.

## Logo Placement

- The logo should be used in its entirety and must not be altered in any way.
  - As an exception, you may add an outline or shadow to the logo to improve visibility against the background. 
- The logo should not be animated or used as part of a pattern or background.
  - Exception: When used in a video, transition animations may be used, provided they do not make significant changes
    to the shape or style of the logo.
- The logo should be used in a way that provides sufficient contrast and visibility.
- The logo should be positioned at a reasonable distance from other elements to ensure clear visibility and legibility.

## Logo Colors

- The logo should always be used in its original colors. Several color variants are available for you to choose from; if these are unsuitable for your use, please reach out to bd_ to discuss options. 
- Please use the logo assets found here: [Download](/img/modular_avatar_logo.zip)

## Contact

For questions, please contact bd_ at:

* Discord: bd_
* Twitter: @bd_j
* Misskey: @bd_@misskey.niri.la
* Email: bd_@nadena.dev