﻿# ロゴ使用ガイドライン

Modular Avatarのロゴは、Modular Avatarを使って一貫した方法で簡単にインストールできることをユーザーに示すことを目的としています。混乱を避けるため、製品を宣伝する際にModular Avatarのロゴを使用する際のガイドラインを用意しています。

このガイドラインに沿った利用に関しては、事前許可なくロゴを利用できますが、ロゴの使用が適切であるかどうかの最終的な判断は[bd_](https://misskey.niri.la/@bd_)および[pumo](https://twitter.com/pumony)に委ねられます。不適切だと判断された場合は利用を中止していただく場合があります。

また、ガイドラインにそぐわない場合でも、ご連絡くだされば個別検討できる場合があります。下記の連絡先にてbd_にお気軽にご連絡ください。

## 適用製品

- Modular Avatarを使用して導入できるPrefabを含む製品（アバター、衣装など）の宣伝で使用できます。
  - ただし、該当Prefabに設定済みのModular Avatarコンポーネントを含む場合に限ります。 
  - Modular Avatarを使用しない代替のPrefabなどを含めることができますが、Modular Avatarはアセットをインストールする主要な方法にする必要があります。
- [NDM Framework](https://github.com/bdunderscore/ndmf)を使用し、Modular Avatarと互換性がある（または依存関係として要求する）アバター改変・作成用の非破壊エディタ拡張の宣伝にも使用できます。
  - エディタ拡張に適用する場合、元のアバターに対して破壊的な変更を加えてはいけません。Prefabなどの設定オブジェクト
  　を削除することでアンインストールが完了する必要があります。
  - インストール手順の過程で、または設定を変更した際に、何らかの処理や生成操作を手動でトリガーすることを要求してはいけません。
  - エディタ内などの独自に実装したUIにはModular Avatarのロゴを使用してはいけません（どこが本家Modular Avatarなのかを明白にするため） 
- Modular Avatarが製品を承認または推奨したと思われるような方法でロゴを提示してはいけません。
- 製品の要件を満たしている場合は、営利・非営利にかかわらずロゴを使用することができます。

## ロゴの配置

- ロゴはそのまま使用してください。 変更や改変をしてはいけません。
  - ただし、背景に対して可視性を向上させるために、ロゴにアウトラインやシャドウを追加することはできます。
- ロゴをアニメーション化したり、パターンや背景の一部として使用されたりしてはいけません。
  - ただし、動画で使う場合は、形やスタイルに大きな変更を加えない限り、トランジションアニメーションを使用することができます。
- ロゴは十分なコントラストと可視性を提供する方法で使用する必要があります。
- ロゴは、他の要素から合理的な距離を保って配置し、明確な可視性と可読性を確保する必要があります。

## ロゴの色

- ロゴは常に元の色で使用する必要があります。いくつかの色のバリエーションを用意していますが、使用に適さない場合は、bd_にご連絡ください。
- 利用する際はこちらのロゴアセットをご利用ください：[ダウンロード](/img/modular_avatar_logo.zip)

## 連絡先

ご不明点や、上記の条件にそぐわない利用許可をお求めの場合は、bd_にてご連絡ください：

* Discord: bd_
* Twitter: @bd_j
* Misskey: @bd_@misskey.niri.la
* Email: bd_@nadena.dev
