﻿# バージョンポリシー

モジュラーアバターは[Semantic Versioning](https://semver.org/lang/ja/)を採用しています。これがどういうことかというと、

* 互換性のない変更が入った場合は、バージョン番号の最初の数字が変わります (例: 1.0.0 -> 2.0.0)。
* 互換性のある新機能が追加された場合は、バージョン番号の2番目の数字が変わります (例: 1.0.0 -> 1.1.0)。例えば1.1.0で作られたアセットは1.0.0では動作しないかもしれませんが、1.0.0で作られたアセットは1.1.0で動作します。
* バグ修正やセーブフォーマットに影響のない変更が入った場合は、バージョン番号の3番目の数字が変わります (1.0.0 -> 1.0.1)。バグ修正がアセットに影響を与えない限り、古いパッチバージョンを使うことは問題にはならないでしょう。

原則として、同じメジャーバージョン（1.x.xなど）の中で最新版を使うことをお勧めします。

## internal関数とパス引用

`internal`指定のクラス・関数名などは安定APIとして扱わないため、いつでも変更される可能性があります。パッチリリース（1.0.0 ->
1.0.1）
でも変更される可能性があるのでご注意ください。また、NDMFパスの「qualified name」も安定APIとして扱わないし、その順番もまた予告なく
変更となる可能性があります。ただし、プラグイン自体の「qualified name」である`nadena.dev.modular-avatar`は安定APIとして扱い、
今後変更されません。

Modular Avatar内部のパスを引用するユースケースがある場合は、githubで詳しいユースケースを機能リクエストを出してください。
安定APIとして追加することを検討します。